#include <bits/stdc++.h>
using namespace std;

const int MAXN = 21;
int64_t grid[MAXN][MAXN];
int N, M, P;

map<pair<int, int>, vector<int64_t>> generate_half_paths_start(int steps) {
    map<pair<int, int>, vector<int64_t>> freq;

    function<void(int, int, int64_t, int)> dfs =
        [&](int r, int c, int64_t cur_sum, int steps_left) {
            if(steps_left == 0) {
                if(!freq.count({r, c})) {
                    freq[{r, c}] = vector<int64_t>(P, 0);
                }
                freq[{r, c}][cur_sum % P]++;
                return;
            }

            if(c + 1 < M) {
                dfs(r, c + 1, cur_sum + grid[r][c + 1], steps_left - 1);
            }

            if(r + 1 < N) {
                dfs(r + 1, c, cur_sum + grid[r + 1][c], steps_left - 1);
            }
        };

    dfs(0, 0, grid[0][0], steps);

    return freq;
}

map<pair<int, int>, vector<int64_t>> generate_half_paths_end(int steps) {
    map<pair<int, int>, vector<int64_t>> freq;

    function<void(int, int, int64_t, int)> dfs =
        [&](int r, int c, int64_t cur_sum, int steps_left) {
            if(steps_left == 0) {
                if(!freq.count({r, c})) {
                    freq[{r, c}] = vector<int64_t>(P, 0);
                }
                freq[{r, c}][cur_sum % P]++;
                return;
            }

            if(c - 1 >= 0) {
                dfs(r, c - 1, cur_sum + grid[r][c - 1], steps_left - 1);
            }

            if(r - 1 >= 0) {
                dfs(r - 1, c, cur_sum + grid[r - 1][c], steps_left - 1);
            }
        };

    dfs(N - 1, M - 1, grid[N - 1][M - 1], steps);

    return freq;
}

int64_t count_divisible_paths() {
    auto freq_all_cells_a = generate_half_paths_start(N - 1);
    auto freq_all_cells_b = generate_half_paths_end(M - 1);

    int64_t total_paths = 0;
    for(auto [cell_a, freq_a]: freq_all_cells_a) {
        if(freq_all_cells_b.find(cell_a) == freq_all_cells_b.end()) {
            continue;
        }

        auto freq_b = freq_all_cells_b[cell_a];
        for(int fwd_sum = 0; fwd_sum < P; fwd_sum++) {
            int64_t needed =
                (P - fwd_sum + grid[cell_a.first][cell_a.second]) % P;
            total_paths += freq_a[fwd_sum] * freq_b[needed];
        }
    }

    return total_paths;
}

int main() {
    cin >> N >> M >> P;
    for(int i = 0; i < N; i++) {
        for(int j = 0; j < M; j++) {
            cin >> grid[i][j];
        }
    }

    cout << count_divisible_paths() << endl;
    return 0;
}
